
import os,string

from common import *
import FS_file_system
import thing

PATH_THINGS=os.path.join('data','things')

class ThingFactory(FS_file_system.FS_file_system):
  def __init__(s,game,path=None):
    s.game=game
    s.things={}
    if path is None: path=PATH_THINGS
    s.FS_walk_and_load_config(s.load_config,path)

  def create_tile(s,pos,tiles):
#    print 'NEW tile:',pos,tiles
    thingdata=[]
    for t in tiles: thingdata.append( s.things[t] )
    tile=thing.Thing_is_tile( s.game, pos, thingdata )
    return tile
  def create_objects(s,pos,objects):
    print 'NEW obj:',pos,objects
    return []

  def has_type(s,type):
    return s.things.has_key(type)

  def load_config(s,dir,conf):
    if DEBUG: print 'loading',dir,conf
    mode=None
    vals=None
    for l in open(conf).readlines():
      sl=string.strip(l)
      if sl:
        if mode is None:
          if string.lower(sl) not in [ 'things','things']:
            print "ThingFactory: load_conf: Not thing conf",conf
          mode=0
        elif mode==0:
          if sl[0]=='[' and sl[-1]==']':
            mode=1
            vals=[ ('name',sl[1:-1]), ('dir',dir), ]
        elif mode==1:
          p=string.find(sl,'=')
          if p==-1:
            raise 'ThingFactory: load_conf: line not of form key=val, missing =',(conf,sl)
          key=string.strip(sl[:p])
          val=string.strip(sl[p+1:])
          if key=='image': s.game.image_cache(dir,val)
          vals.append( (key,val) )
        else:
          raise 'ThingFactory: load_conf: unknown mode!',(conf,mode)
      else:
        if mode==1:
          s.load_thing(vals)
          vals=None
        mode=0
    if vals is not None:
      s.load_thing(vals)
  def load_thing(s,vals):
    k,name=vals[0]
    if k!='name': raise 'ThingFactory: load_thing: no name!',vals
    s.things[ name ]=vals


def main():
  t=ThingFactory()
  print s.things

if __name__=="__main__": main()
