
import os,string

import pygame
from pygame.locals import *

from common import *
import FS_file_system
import thing

PATH_MAPS=os.path.join('data','maps')



class Map(FS_file_system.FS_file_system):
  def __init__(s,game,name,path=None):
    # sdl stuff
    s.SDL_map_rect=pygame.Rect( 0,0,game.SDL_wsize[0],game.SDL_wsize[1] )
    s.SDL_map = pygame.Surface(game.SDL_screen.get_size()).convert()
    s.redraw=1
    s.SDL_bgcolor=(255,0,0)
    # game stuff
    s.game=game
    s.mapkey={}
    s.map={}
    s.size=[0,0]
    s.load(name)

  def SDL_refresh(s):
    if s.redraw:
      s.SDL_map.fill( s.SDL_bgcolor )
      s.game.SDLGR_map.draw( s.SDL_map )
      s.redraw=0

  def load(s,name,path=None):
    if path is None: path=PATH_MAPS
    paths=s.FS_walk_and_find_file(name,path)
    if len(paths)>1: raise 'Map.load: more than one map of that name',paths
    s.load_map(paths[0])
  def load_map(s,path):
    mode=None
    x=y=0
    for l in open(path).readlines():
      sl=string.strip(l)
      if mode is None:
        if sl=='KEY':
          mode=1
      elif mode==1:  # KEYS
        if sl=='-'*len(sl) or sl=='='*len(sl):
          pass
        elif not sl:
          pass
        elif sl=='MAP':
          mode=mode+1
        else:
          spl=string.split(l,':')
          if len(spl)!=3: raise 'Map.load: key doesnt have a ":"',l
          if len(spl[0])!=1: raise 'Map.load: ":" out of place',l
          k=spl[0]
          tile=[]
          for type in string.split(spl[1],','):
            print 'load map',spl,type
            type=string.strip(type)
            if type:
              if not s.game.fact_has_type(type):
                raise 'Map.load: cant find tile type',(type,spl)
              tile.append(type)
          objects=[]
          for type in string.split(spl[2],','):
            type=string.strip(type)
            if type:
              if not s.game.fact_has_type(type):
                raise 'Map.load: cant find object type',(type,spl)
              tile.append(type)
          s.mapkey[k]=(tile,objects)
      elif mode==2: # map
        if sl=='-'*len(sl) or sl=='='*len(sl):
          pass
        elif not sl:
          pass
        else:
          x=0
          for c in string.rstrip(l):
            if not s.mapkey.has_key( c ):
              raise 'Map.load: unknown map character',(x,y,c)
            pos=(x,y)
            tile,objects=s.mapkey[c]
            s.game.fact_create_tile(pos, tile )
#            s.game.fact_create_objects(pos, objects)
#            s.map[ pos ]= thing.Thing_is_tile( pos, s.mapkey[ c ] )
            x=x+1
            if x>s.size[0]: s.size[0]=x
          y=y+1
          if y>s.size[1]: s.size[1]=y


def main():
  m=Map('level0')

if __name__=="__main__": main()


