

import time
import pygame

from common import *


class base_Thing(pygame.sprite.Sprite):
  def __init__(s,game,pos,decor):
    # SDL stuff
    pygame.sprite.Sprite.__init__(s) #call Sprite initializer
    # generic
    s.properties={}  # los block %, move cost, etc
    s.game=game
    s.pos=pos
    s.decor=decor
    s.redraw=1
    # SDL stuff
    s.images=s.game.images
    s.image=pygame.Surface( [s.game.tilesize(),s.game.tilesize()] ).convert()
#    s.image_current=None
    s.rect=pygame.Rect( pos[0]*s.game.tilesize(),
                        pos[1]*s.game.tilesize(),
                        0,
                        0 )
    print "on init...",s.rect
#    print 'baseThing',pos,decor
    s.setup()

  brains=None        # no brains

  def update(s,*args):
    raise 'You need to catch updates for this object',(s,args)

  def setup(s):
    dir=None
    for a_decor in s.decor:
      for k,v in a_decor:
        if k=='dir': dir=v
        if k=='image':
#          print 'cache image',s.game.images[ v ]
#          s.image=s.images[ v ]
          s.image.blit( s.images[v], AT_0_0 )
#        print s.pos,k,v
#    print 'setup  image==',s.image,s.rect

  def image_set(s,name):
    if s.image_current!=name:
      s.image=s.images[name]
      s.image_current=name


class Thing_is_tile(base_Thing):
  def __init__(s,game,pos,data):
    base_Thing.__init__(s, game, pos,data)
    s.light=0
    s.light_sources=None # list of light sources
    s.contains=[]        # things that are in this square (also draw order)
    s.properties={}      # _generated_ from contains
                         # ie tile[s], decorator[s], static object, properties
    # SDL
    s.rect.h=s.game.tilesize()
    s.rect.w=s.game.tilesize()

  def update(s,cmd,*args):
    if cmd==UPDATE_THING__OFFSET_DELTA:
      pos,group,rect=args
#      print 'b4',s.rect,pos
      apply( s.rect.move_ip, pos )
#      print 'post',s.rect,pos
      if rect.colliderect(s.rect): group.add( s )
    else:
      raise 'baseTile.update: uncaught update',(cmd,args)

class base_Thing_needs_brains(base_Thing):
  def brains(s):
    print 'called brain'

class Thing_is_object(base_Thing_needs_brains):
  pass


